
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;

public class Hzassg {

    private final Szemly frj;
    private final Szemly felesg;
    private final Szemly frjTanja;
    private final Szemly felesgTanja;
    private final String hzassgktsHelye;
    private final Date hzassgktsIdeje;
    private final Collection<Nszajndk> nszajndkok;

    public Hzassg(Szemly frj, Szemly felesg, Szemly frjTanja, Szemly felesgTanja,
            String hzassgktsHelye, Date hzassgktsIdeje) throws IdentitsZavarosKivtel {
        if(frj.nem() != Nem.FRFI) {
            throw new IdentitsZavarosKivtel(frj);
        }
        if(felesg.nem() != Nem.N) {
            throw new IdentitsZavarosKivtel(felesg);
        }
        this.frj = frj;
        this.felesg = felesg;
        this.frjTanja = frjTanja;
        this.felesgTanja = felesgTanja;
        this.hzassgktsHelye = hzassgktsHelye;
        this.hzassgktsIdeje = hzassgktsIdeje;
        this.nszajndkok = new ArrayList<>();
    }

    public void jNszajndk(Nszajndk nszajndk) {
        this.nszajndkok.add(nszajndk);
    }

    public Collection<Nszajndk> nszajndkok() {
        return this.nszajndkok;
    }

    public Szemly frj() {
        return this.frj;
    }

    public Szemly felesg() {
        return this.felesg;
    }

    public Szemly frjTanja() {
        return this.frjTanja;
    }

    public Szemly felesgTanja() {
        return this.felesgTanja;
    }

    public String hzassgktsHelye() {
        return this.hzassgktsHelye;
    }

    public Date hzassgktsIdeje() {
        return this.hzassgktsIdeje;
    }

    public void szentest() throws BigmistaKivtel {
        frj.hzasodik(this);
        felesg.hzasodik(this);
    }

    public void vls() throws SzingliVlniAkarKivtel {
        this.frj.vlik();
        this.felesg.vlik();
    }
}
